
/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "struct_gpgme_sig_notation.h"

ScmObj gpgme_sig_notation_allocate( ScmClass *klass, ScmObj initargs )
{
     Scm_GPGME_SIG_NOTATION *p = SCM_NEW( Scm_GPGME_SIG_NOTATION );
     SCM_SET_CLASS( p, SCM_CLASS_GPGME_SIG_NOTATION );

     p->obj = NULL;

     return SCM_OBJ( p );
}

SCM_DEFINE_BUILTIN_CLASS( Scm_GPGME_SIG_NOTATIONClass, NULL, NULL, NULL,
                          gpgme_sig_notation_allocate, NULL );

ScmObj gpgme_sig_notation_name( Scm_GPGME_SIG_NOTATION *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->name == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->name );
     }
}

ScmObj gpgme_sig_notation_value( Scm_GPGME_SIG_NOTATION *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->value == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->value );
     }
}

ScmObj gpgme_sig_notation_name_len( Scm_GPGME_SIG_NOTATION *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->name_len );
}

ScmObj gpgme_sig_notation_value_len( Scm_GPGME_SIG_NOTATION *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->value_len );
}

ScmObj gpgme_sig_notation_flags( Scm_GPGME_SIG_NOTATION *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->flags );
}

ScmObj gpgme_sig_notation_human_readable( Scm_GPGME_SIG_NOTATION *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->human_readable );
}

ScmObj gpgme_sig_notation_critical( Scm_GPGME_SIG_NOTATION *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->critical );
}
