
/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "struct_gpgme_sign_result.h"

ScmObj gpgme_sign_result_allocate( ScmClass *klass, ScmObj initargs )
{
     Scm_GPGME_SIGN_RESULT *p = SCM_NEW( Scm_GPGME_SIGN_RESULT );
     SCM_SET_CLASS( p, SCM_CLASS_GPGME_SIGN_RESULT );

     p->obj = NULL;

     return SCM_OBJ( p );
}

SCM_DEFINE_BUILTIN_CLASS( Scm_GPGME_SIGN_RESULTClass, NULL, NULL, NULL,
                          gpgme_sign_result_allocate, NULL );

ScmObj gpgme_sign_result_invalid_signers( Scm_GPGME_SIGN_RESULT *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->invalid_signers == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_INVALID_KEY *q = SCM_GPGME_INVALID_KEY(
         gpgme_invalid_key_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->invalid_signers;
     return SCM_OBJ( q );
}

ScmObj gpgme_sign_result_signatures( Scm_GPGME_SIGN_RESULT *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->signatures == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_NEW_SIGNATURE *q = SCM_GPGME_NEW_SIGNATURE(
         gpgme_new_signature_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->signatures;
     return SCM_OBJ( q );
}
