
/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "struct_gpgme_tofu_info.h"

ScmObj gpgme_tofu_info_allocate( ScmClass *klass, ScmObj initargs )
{
     Scm_GPGME_TOFU_INFO *p = SCM_NEW( Scm_GPGME_TOFU_INFO );
     SCM_SET_CLASS( p, SCM_CLASS_GPGME_TOFU_INFO );

     p->obj = NULL;

     return SCM_OBJ( p );
}

SCM_DEFINE_BUILTIN_CLASS( Scm_GPGME_TOFU_INFOClass, NULL, NULL, NULL,
                          gpgme_tofu_info_allocate, NULL );

ScmObj gpgme_tofu_info_validity( Scm_GPGME_TOFU_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->validity );
}

ScmObj gpgme_tofu_info_policy( Scm_GPGME_TOFU_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->policy );
}

ScmObj gpgme_tofu_info__rfu( Scm_GPGME_TOFU_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->_rfu );
}

ScmObj gpgme_tofu_info_signcount( Scm_GPGME_TOFU_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->signcount );
}

ScmObj gpgme_tofu_info_encrcount( Scm_GPGME_TOFU_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->encrcount );
}

ScmObj gpgme_tofu_info_signfirst( Scm_GPGME_TOFU_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->signfirst );
}

ScmObj gpgme_tofu_info_signlast( Scm_GPGME_TOFU_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->signlast );
}

ScmObj gpgme_tofu_info_encrfirst( Scm_GPGME_TOFU_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->encrfirst );
}

ScmObj gpgme_tofu_info_encrlast( Scm_GPGME_TOFU_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->encrlast );
}

ScmObj gpgme_tofu_info_description( Scm_GPGME_TOFU_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->description == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->description );
     }
}
