;;; 
;;; one line to give the Gauche-_gpgme and an idea of what it does.
;;; Copyright (C) 2017 aaauuue 

;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or (at your option) any later version.

;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.

;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;;; 

;;;
;;; _gpgme
;;;

(define-module _gpgme
  (export test-_gpgme ;; dummy

          <gpgme-context>
          <gpgme-data>
          <gpgme-engine-info>
          <gpgme-invalid-key>
          <gpgme-key>
          <gpgme-key-sig>
          <gpgme-new-signature>
          <gpgme-sig-notation>
          <gpgme-sign-result>
          <gpgme-signature>
          <gpgme-subkey>
          <gpgme-tofu-info>
          <gpgme-user-id>
          <gpgme-verify-result>

          GPGME-DATA-ENCODING-NONE
          GPGME-DATA-ENCODING-BINARY
          GPGME-DATA-ENCODING-BASE64
          GPGME-DATA-ENCODING-ARMOR
          GPGME-DATA-ENCODING-URL
          GPGME-DATA-ENCODING-URLESC
          GPGME-DATA-ENCODING-URL0
          GPGME-DATA-ENCODING-MIME

          GPGME-DATA-TYPE-INVALID
          GPGME-DATA-TYPE-UNKNOWN
          GPGME-DATA-TYPE-PGP-SIGNED
          GPGME-DATA-TYPE-PGP-ENCRYPTED
          GPGME-DATA-TYPE-PGP-OTHER
          GPGME-DATA-TYPE-PGP-KEY
          GPGME-DATA-TYPE-PGP-SIGNATURE
          GPGME-DATA-TYPE-CMS-SIGNED
          GPGME-DATA-TYPE-CMS-ENCRYPTED
          GPGME-DATA-TYPE-CMS-OTHER
          GPGME-DATA-TYPE-X509-CERT
          GPGME-DATA-TYPE-PKCS12


          GPGME-PK-RSA
          GPGME-PK-RSA-E
          GPGME-PK-RSA-S
          GPGME-PK-ELG-E
          GPGME-PK-DSA
          GPGME-PK-ECC
          GPGME-PK-ELG
          GPGME-PK-ECDSA
          GPGME-PK-ECDH
          GPGME-PK-EDDSA

          GPGME-MD-NONE
          GPGME-MD-MD5
          GPGME-MD-SHA1
          GPGME-MD-RMD160
          GPGME-MD-MD2
          GPGME-MD-TIGER
          GPGME-MD-HAVAL
          GPGME-MD-SHA256
          GPGME-MD-SHA384
          GPGME-MD-SHA512
          GPGME-MD-SHA224
          GPGME-MD-MD4
          GPGME-MD-CRC32
          GPGME-MD-CRC32-RFC1510
          GPGME-MD-CRC24-RFC2440

          GPGME-SIG-MODE-NORMAL
          GPGME-SIG-MODE-DETACH
          GPGME-SIG-MODE-CLEAR

          GPGME-VALIDITY-UNKNOWN
          GPGME-VALIDITY-UNDEFINED
          GPGME-VALIDITY-NEVER
          GPGME-VALIDITY-MARGINAL
          GPGME-VALIDITY-FULL
          GPGME-VALIDITY-ULTIMATE

          GPGME-TOFU-POLICY-NONE
          GPGME-TOFU-POLICY-AUTO
          GPGME-TOFU-POLICY-GOOD
          GPGME-TOFU-POLICY-UNKNOWN
          GPGME-TOFU-POLICY-BAD
          GPGME-TOFU-POLICY-ASK

          GPGME-PROTOCOL-OpenPGP
          GPGME-PROTOCOL-CMS
          GPGME-PROTOCOL-GPGCONF
          GPGME-PROTOCOL-ASSUAN
          GPGME-PROTOCOL-G13
          GPGME-PROTOCOL-UISERVER
          GPGME-PROTOCOL-SPAWN
          GPGME-PROTOCOL-DEFAULT
          GPGME-PROTOCOL-UNKNOWN

          GPGME-KEYLIST-MODE-LOCAL
          GPGME-KEYLIST-MODE-EXTERN
          GPGME-KEYLIST-MODE-SIGS
          GPGME-KEYLIST-MODE-SIG-NOTATIONS
          GPGME-KEYLIST-MODE-WITH-SECRET
          GPGME-KEYLIST-MODE-WITH-TOFU
          GPGME-KEYLIST-MODE-EPHEMERAL
          GPGME-KEYLIST-MODE-VALIDATE

          GPGME-PINENTRY-MODE-DEFAULT
          GPGME-PINENTRY-MODE-ASK
          GPGME-PINENTRY-MODE-CANCEL
          GPGME-PINENTRY-MODE-ERROR
          GPGME-PINENTRY-MODE-LOOPBACK

          GPGME-EXPORT-MODE-EXTERN
          GPGME-EXPORT-MODE-MINIMAL
          GPGME-EXPORT-MODE-SECRET
          GPGME-EXPORT-MODE-RAW
          GPGME-EXPORT-MODE-PKCS12

          GPGME-AUDITLOG-HTML
          GPGME-AUDITLOG-WITH-HELP

          GPGME-SIG-NOTATION-HUMAN-READABLE
          GPGME-SIG-NOTATION-CRITICAL

          GPGME-EVENT-START
          GPGME-EVENT-DONE
          GPGME-EVENT-NEXT-KEY
          GPGME-EVENT-NEXT-TRUSTITEM

          GPGME-ENCRYPT-ALWAYS-TRUST
          GPGME-ENCRYPT-NO-ENCRYPT-TO
          GPGME-ENCRYPT-PREPARE
          GPGME-ENCRYPT-EXPECT-SIGN
          GPGME-ENCRYPT-NO-COMPRESS
          GPGME-ENCRYPT-SYMMETRIC
          GPGME-ENCRYPT-THROW-KEYIDS
          GPGME-ENCRYPT-WRAP

          GPGME-DECRYPT-VERIFY
          GPGME-DECRYPT-UNWRAP

          GPGME-SIGSUM-VALID
          GPGME-SIGSUM-GREEN
          GPGME-SIGSUM-RED
          GPGME-SIGSUM-KEY-REVOKED
          GPGME-SIGSUM-KEY-EXPIRED
          GPGME-SIGSUM-SIG-EXPIRED
          GPGME-SIGSUM-KEY-MISSING
          GPGME-SIGSUM-CRL-MISSING
          GPGME-SIGSUM-CRL-TOO-OLD
          GPGME-SIGSUM-BAD-POLICY
          GPGME-SIGSUM-SYS-ERROR
          GPGME-SIGSUM-TOFU-CONFLICT

          GPGME-IMPORT-NEW
          GPGME-IMPORT-UID
          GPGME-IMPORT-SIG
          GPGME-IMPORT-SUBKEY
          GPGME-IMPORT-SECRET

          GPGME-CREATE-SIGN
          GPGME-CREATE-ENCR
          GPGME-CREATE-CERT
          GPGME-CREATE-AUTH
          GPGME-CREATE-NOPASSWD
          GPGME-CREATE-SELFSIGNED
          GPGME-CREATE-NOSTORE
          GPGME-CREATE-WANTPUB
          GPGME-CREATE-WANTSEC
          GPGME-CREATE-FORCE
          GPGME-CREATE-NOEXPIRE

          GPGME-KEYSIGN-LOCAL
          GPGME-KEYSIGN-LFSEP
          GPGME-KEYSIGN-NOEXPIRE


          GPGME-INTERACT-CARD

          GPGME-SPAWN-DETACHED
          GPGME-SPAWN-ALLOW-SET-FG

          GPGME-CONF-BASIC
          GPGME-CONF-ADVANCED
          GPGME-CONF-EXPERT
          GPGME-CONF-INVISIBLE
          GPGME-CONF-INTERNAL


          GPGME-CONF-NONE
          GPGME-CONF-STRING
          GPGME-CONF-INT32
          GPGME-CONF-UINT32

          GPGME-CONF-FILENAME
          GPGME-CONF-LDAP-SERVER
          GPGME-CONF-KEY-FPR
          GPGME-CONF-PUB-KEY
          GPGME-CONF-SEC-KEY
          GPGME-CONF-ALIAS-LIST

          GPGME-CONF-GROUP
          GPGME-CONF-OPTIONAL
          GPGME-CONF-LIST
          GPGME-CONF-RUNTIME
          GPGME-CONF-DEFAULT
          GPGME-CONF-DEFAULT-DESC
          GPGME-CONF-NO-ARG-DESC
          GPGME-CONF-NO-CHANGE

          GPGME-STATUS-EOF
          GPGME-STATUS-ENTER
          GPGME-STATUS-LEAVE
          GPGME-STATUS-ABORT

          GPGME-STATUS-GOODSIG
          GPGME-STATUS-BADSIG
          GPGME-STATUS-ERRSIG

          GPGME-STATUS-BADARMOR

          GPGME-STATUS-RSA-OR-IDEA
          GPGME-STATUS-KEYEXPIRED
          GPGME-STATUS-KEYREVOKED

          GPGME-STATUS-TRUST-UNDEFINED
          GPGME-STATUS-TRUST-NEVER
          GPGME-STATUS-TRUST-MARGINAL
          GPGME-STATUS-TRUST-FULLY
          GPGME-STATUS-TRUST-ULTIMATE

          GPGME-STATUS-SHM-INFO
          GPGME-STATUS-SHM-GET
          GPGME-STATUS-SHM-GET-BOOL
          GPGME-STATUS-SHM-GET-HIDDEN

          GPGME-STATUS-NEED-PASSPHRASE
          GPGME-STATUS-VALIDSIG
          GPGME-STATUS-SIG-ID
          GPGME-STATUS-ENC-TO
          GPGME-STATUS-NODATA
          GPGME-STATUS-BAD-PASSPHRASE
          GPGME-STATUS-NO-PUBKEY
          GPGME-STATUS-NO-SECKEY
          GPGME-STATUS-NEED-PASSPHRASE-SYM
          GPGME-STATUS-DECRYPTION-FAILED
          GPGME-STATUS-DECRYPTION-OKAY
          GPGME-STATUS-MISSING-PASSPHRASE
          GPGME-STATUS-GOOD-PASSPHRASE
          GPGME-STATUS-GOODMDC
          GPGME-STATUS-BADMDC
          GPGME-STATUS-ERRMDC
          GPGME-STATUS-IMPORTED
          GPGME-STATUS-IMPORT-OK
          GPGME-STATUS-IMPORT-PROBLEM
          GPGME-STATUS-IMPORT-RES
          GPGME-STATUS-FILE-START
          GPGME-STATUS-FILE-DONE
          GPGME-STATUS-FILE-ERROR

          GPGME-STATUS-BEGIN-DECRYPTION
          GPGME-STATUS-END-DECRYPTION
          GPGME-STATUS-BEGIN-ENCRYPTION
          GPGME-STATUS-END-ENCRYPTION

          GPGME-STATUS-DELETE-PROBLEM
          GPGME-STATUS-GET-BOOL
          GPGME-STATUS-GET-LINE
          GPGME-STATUS-GET-HIDDEN
          GPGME-STATUS-GOT-IT
          GPGME-STATUS-PROGRESS
          GPGME-STATUS-SIG-CREATED
          GPGME-STATUS-SESSION-KEY
          GPGME-STATUS-NOTATION-NAME
          GPGME-STATUS-NOTATION-DATA
          GPGME-STATUS-POLICY-URL
          GPGME-STATUS-BEGIN-STREAM
          GPGME-STATUS-END-STREAM
          GPGME-STATUS-KEY-CREATED
          GPGME-STATUS-USERID-HINT
          GPGME-STATUS-UNEXPECTED
          GPGME-STATUS-INV-RECP
          GPGME-STATUS-NO-RECP
          GPGME-STATUS-ALREADY-SIGNED
          GPGME-STATUS-SIGEXPIRED
          GPGME-STATUS-EXPSIG
          GPGME-STATUS-EXPKEYSIG
          GPGME-STATUS-TRUNCATED
          GPGME-STATUS-ERROR
          GPGME-STATUS-NEWSIG
          GPGME-STATUS-REVKEYSIG
          GPGME-STATUS-SIG-SUBPACKET
          GPGME-STATUS-NEED-PASSPHRASE-PIN
          GPGME-STATUS-SC-OP-FAILURE
          GPGME-STATUS-SC-OP-SUCCESS
          GPGME-STATUS-CARDCTRL
          GPGME-STATUS-BACKUP-KEY-CREATED
          GPGME-STATUS-PKA-TRUST-BAD
          GPGME-STATUS-PKA-TRUST-GOOD
          GPGME-STATUS-PLAINTEXT
          GPGME-STATUS-INV-SGNR
          GPGME-STATUS-NO-SGNR
          GPGME-STATUS-SUCCESS
          GPGME-STATUS-DECRYPTION-INFO
          GPGME-STATUS-PLAINTEXT-LENGTH
          GPGME-STATUS-MOUNTPOINT
          GPGME-STATUS-PINENTRY-LAUNCHED
          GPGME-STATUS-ATTRIBUTE
          GPGME-STATUS-BEGIN-SIGNING
          GPGME-STATUS-KEY-NOT-CREATED
          GPGME-STATUS-INQUIRE-MAXLEN
          GPGME-STATUS-FAILURE
          GPGME-STATUS-KEY-CONSIDERED
          GPGME-STATUS-TOFU-USER
          GPGME-STATUS-TOFU-STATS
          GPGME-STATUS-TOFU-STATS-LONG
          GPGME-STATUS-NOTATION-FLAGS

          GPGME-SIG-STAT-NONE
          GPGME-SIG-STAT-GOOD
          GPGME-SIG-STAT-BAD
          GPGME-SIG-STAT-NOKEY
          GPGME-SIG-STAT-NOSIG
          GPGME-SIG-STAT-ERROR
          GPGME-SIG-STAT-DIFF
          GPGME-SIG-STAT-GOOD-EXP
          GPGME-SIG-STAT-GOOD-EXPKEY

          GPGME-ATTR-KEYID
          GPGME-ATTR-FPR
          GPGME-ATTR-ALGO
          GPGME-ATTR-LEN
          GPGME-ATTR-CREATED
          GPGME-ATTR-EXPIRE
          GPGME-ATTR-OTRUST
          GPGME-ATTR-USERID
          GPGME-ATTR-NAME
          GPGME-ATTR-EMAIL
          GPGME-ATTR-COMMENT
          GPGME-ATTR-VALIDITY
          GPGME-ATTR-LEVEL
          GPGME-ATTR-TYPE
          GPGME-ATTR-IS-SECRET
          GPGME-ATTR-KEY-REVOKED
          GPGME-ATTR-KEY-INVALID
          GPGME-ATTR-UID-REVOKED
          GPGME-ATTR-UID-INVALID
          GPGME-ATTR-KEY-CAPS
          GPGME-ATTR-CAN-ENCRYPT
          GPGME-ATTR-CAN-SIGN
          GPGME-ATTR-CAN-CERTIFY
          GPGME-ATTR-KEY-EXPIRED
          GPGME-ATTR-KEY-DISABLED
          GPGME-ATTR-SERIAL
          GPGME-ATTR-ISSUER
          GPGME-ATTR-CHAINID
          GPGME-ATTR-SIG-STATUS
          GPGME-ATTR-ERRTOK
          GPGME-ATTR-SIG-SUMMARY
          GPGME-ATTR-SIG-CLASS

          %init-gpgme

          %gpgme-set-passphrase-cb
          %gpgme-check-version
          %gpgme-new-context
          %gpgme-release-context
          %gpgme-new-data
          %gpgme-release-data
          %gpgme-new-data-from-file
          %gpgme-new-data-from-string
          %gpgme-set-protocol
          %gpgme-set-armor
          %gpgme-set-textmode
          %gpgme-op-keylist-start
          %gpgme-op-keylist-next
          %gpgme-op-keylist-end
          %gpgme-get-key
          %gpgme-signers-clear
          %gpgme-signers-add
          %gpgme-op-sign
          %gpgme-op-verify
          %gpgme-op-verify-result
          %gpgme-op-export-keys
          %gpgme-data-seek
          %gpgme-data-read
          %gpgme-op-encrypt
          %gpgme-op-decrypt
          %gpgme-set-pinentry-mode
          %gpgme-get-pinentry-mode
          )
  )
(select-module _gpgme)

;; Loads extension
(dynamic-load "_gpgme")

;;
;; Put your Scheme definitions here
;;



